package lawOfDemeter;

/**
 * @author Pengcheng Wu
 */

import java.util.*;
import org.aspectj.lang.reflect.*;
import org.aspectj.lang.*;

aspect Checker {

  /**
   * Prints a violation noitice using the thisJoinPoint argument.
   * Also provides a method that can be captured using the included pointcut
   * Checker.Violation().
   *
   * @param thisJoinPoint
   */
  pointcut Violation(JoinPoint.StaticPart ejsp, JoinPoint tjp):
    execution(private void Checker.raiseViolation(JoinPoint.StaticPart, JoinPoint)) && args(ejsp, tjp);
  private void raiseViolation(JoinPoint.StaticPart ejsp, JoinPoint thisJoinPoint){
    System.out.println("!! LoD violation: "+thisJoinPoint+JPUtil.at(ejsp, thisJoinPoint));
  }

  /**
   * Prints a success noitice using the thisJoinPoint argument.
   * Also provides a method that can be captured using the included pointcut
   * Checker.Success().
   *
   * @param thisJoinPoint
   * @param binsIn
   */
  pointcut Success(JoinPoint tjp):
    execution(private void Checker.raiseSuccess(JoinPoint)) && args(tjp);
  private void raiseSuccess(JoinPoint thisJoinPoint){
  }

   before(): Any.ToCheck() {
       Object targetObj = thisJoinPoint.getTarget();
       Class targetType = null;
       if(targetObj != null){
        targetType = thisJoinPoint.getTarget().getClass();
       }
       Class targetDeclaringType = thisJoinPointStaticPart.getSignature().getDeclaringType();
       Class thisType = thisEnclosingJoinPointStaticPart.getSignature().getDeclaringType();

       if(LoDPointCutsGlobal.prefSuppliers.containsKey(thisType)) {
          Class[] alloweds = (Class[])LoDPointCutsGlobal.prefSuppliers.get(thisType);
          for(int i=0; i<alloweds.length; i++) {
            if(targetType==alloweds[i] || targetDeclaringType == alloweds[i]){
               raiseSuccess(thisJoinPoint);
               return;
            }
          }
       }

       if(LoDPointCutsContext.prefSuppliers.contains(targetType) || LoDPointCutsContext.prefSuppliers.contains(targetDeclaringType)){
             raiseSuccess(thisJoinPoint);
             return;
       }

       raiseViolation(thisEnclosingJoinPointStaticPart, thisJoinPoint);
   }

}
