package edu.neu.ccs.com3205.lodchecker.internal;

import org.eclipse.ui.*;

import edu.neu.ccs.com3205.lodchecker.*;

/**
 * LoDPageListener.java
 * This class is currently not used... it was intended to be used in conjunction
 * with the early startUp to ensure that the AspectJ plugin could be activated
 * without error when the first page was opened.  However, registering this listener
 * at early startUp does not capture the first page being opened!? - even though
 * plugin.getWorkbench().getActiveWorkbenchWindow() returns null verifying that there
 * is no page open yet... perhaps future versions of Eclipse will be different allowing
 * for this file to be used.
 * 
 * @author Paul Freeman
 */

public class LoDPageListener implements IPageListener {

  private static LoDCheckerPlugin plugin = LoDCheckerPlugin.getDefault();

	/**
	 * Notifies this listener that the given page has been activated. 
	 */
	public void pageActivated(IWorkbenchPage page) {
		plugin.log("page activated " + page.getLabel());
	}

	/**
	 * Notifies this listener that the given page has been closed. 
	 */
	public void pageClosed(IWorkbenchPage page) {
		plugin.log("page closed " + page.getLabel());
	}

	/**
	 * Notifies this listener that the given page has been opened. 
	 */
	public void pageOpened(IWorkbenchPage page) {
		plugin.log("page opened " + page.getLabel());
	}

}
