package edu.neu.ccs.com3205.lodchecker.internal;


import org.eclipse.ui.*;
import org.eclipse.jface.viewers.*;
import org.eclipse.core.resources.*;
import org.eclipse.jdt.core.*;

import edu.neu.ccs.com3205.lodchecker.*;

import java.util.*;

/**
 * LoDWindowListener.java
 * This class is currently not used... it was intended to be used in conjunction
 * with the early startUp to ensure that the AspectJ plugin could be activated
 * without error when the first window was opened.  However, registering this listener
 * at early startUp does not capture the first window being opened!? - even though
 * plugin.getWorkbench().getActiveWorkbenchWindow() returns null verifying that there
 * is no window open yet... perhaps future versions of Eclipse will be different allowing
 * for this file to be used.
 * 
 * 
 * @author Paul Freeman
 */

public class LoDWindowListener implements IWindowListener {
	
  private static LoDCheckerPlugin plugin = LoDCheckerPlugin.getDefault();

	/**
	 * Notifies this listener that the given window has been activated. 
	 */
	public void windowActivated(IWorkbenchWindow window) {
		plugin.log("window "+window+" activated " + new Date());
	}
  
  /**
   * Notifies this listener that the given window has been closed. 
   */
	public void windowClosed(IWorkbenchWindow window) {
		plugin.log("window "+window+" closed " + new Date());
	}
  
  /**
   * Notifies this listener that the given window has been deactivated. 
   */
	public void windowDeactivated(IWorkbenchWindow window) {
		plugin.log("window "+window+" deactivated " + new Date());
	}
          
	/**
	 * Notifies this listener that the given window has been opened. 
	 */
	public void windowOpened(IWorkbenchWindow window) {
		plugin.log("window "+window+" opened " + new Date());
	}
          
}
