package edu.neu.ccs.com3205.lodchecker.utils;

/**
 * LoDFileFilter.java
 * Helper class to filter out files in the Files.get functions
 * 
 * @author Paul Freeman
 */

import java.util.*;
import java.io.*;

import edu.neu.ccs.com3205.lodchecker.*;

public class LoDFileFilter implements FileFilter{
	private Vector filterList;
	private static LoDCheckerPlugin plugin = LoDCheckerPlugin.getDefault();
		
	/**
	 * @param String[] filters is the list of file filters to use
	 * each filter is compared against the end of the file path
	 */
	public LoDFileFilter(Vector filters){
		filterList = filters;
	}
	
	/**
	 * @return Returns true if the absolute path to the file ends 
	 * with one of the filter sequences using java.lang.String.endsWith(..).
	 * returns false otherwise.
	 */
	public boolean accept(java.io.File aFile){
		Iterator filters = filterList.iterator();
		while(filters.hasNext()){
			String thisFilter = (String)filters.next();
			if(aFile.getAbsolutePath().endsWith(thisFilter.trim())){
//				plugin.log("file: " + aFile.getAbsolutePath() + " ends with " + thisFilter.trim());
				return true;
			}
		}
		return false;
	}
}
